<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 The zen-cart developers                           |
// |                                                                      |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                      |
// | Portions Copyright (c) 2003 osCommerce                               |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+
// $Id: celere3.php 1969 2005-09-13 06:57:21Z drbyte $
//

  class celere3 {
    var $code, $title, $description, $icon, $enabled;

// class constructor
    function celere3() {
      global $order, $db;

      $this->code = 'celere3';
      $this->title = MODULE_SHIPPING_CELERE3_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_CELERE3_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_SHIPPING_CELERE3_SORT_ORDER;
      $this->icon = '';
      $this->tax_class = MODULE_SHIPPING_CELERE3_TAX_CLASS;
      $this->tax_basis = MODULE_SHIPPING_CELERE3_TAX_BASIS;

      // disable only when entire cart is free shipping
      if (zen_get_shipping_enabled($this->code)) {
        $this->enabled = ((MODULE_SHIPPING_CELERE3_STATUS == 'Vero') ? vero : falso);
      }

      if ( ($this->enabled == vero) && ((int)MODULE_SHIPPING_CELERE3_ZONE > 0) ) {
        $check_flag = falso;
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_CELERE3_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag =  vero;
            break;
          } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = vero;
            break;
          }
          $check->MoveNext();
        }

        if ($check_flag == falso) {
          $this->enabled = falso;
        }
      }
    }

// class methods
    function quote($method = '') {
      global $order;

      $this->quotes = array('id' => $this->code,
                            'module' => MODULE_SHIPPING_CELERE3_TEXT_TITLE,
                            'methods' => array(array('id' => $this->code,
                                                     'title' => MODULE_SHIPPING_CELERE3_TEXT_WAY,
                                                     'cost' => MODULE_SHIPPING_CELERE3_COST)));
      if ($this->tax_class > 0) {
        $this->quotes['tax'] = zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      }

      if (zen_not_null($this->icon)) $this->quotes['icon'] = zen_image($this->icon, $this->title);

      return $this->quotes;
    }

    function check() {
      global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_CELERE3_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Abilita la spedizione via Paccocelere 3', 'MODULE_SHIPPING_CELERE3_STATUS', 'Vero', 'Vuoi offrire la spedizione via Paccocelere 3?', '6', '0', 'zen_cfg_select_option(array(\'Vero\', \'Falso\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Spese di spedizione', 'MODULE_SHIPPING_CELERE3_COST', '9.10', 'Spese di spedizione per Paccocelere 3 fino a 30 KG.', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Zona di spedizione', 'MODULE_SHIPPING_CELERE3_ZONE', '0', 'Se viene selezionata una zona, il metodo di spedizione viene abilitato solo per la zona indicata.', '6', '0', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Ordine di visualizzazione', 'MODULE_SHIPPING_CELERE3_SORT_ORDER', '0', 'Ordine di visualizzazione.', '6', '0', now())");
    }

    function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_SHIPPING_CELERE3_STATUS', 'MODULE_SHIPPING_CELERE3_COST', 'MODULE_SHIPPING_CELERE3_ZONE', 'MODULE_SHIPPING_CELERE3_SORT_ORDER');
    }
  }
?>
